Skip to content
Extraits de code Groupes Projets
Valider fc688a6e rédigé par cam.lafit's avatar cam.lafit
Parcourir les fichiers

Typo : prefer ${..} syntax

* Use unique syntax variable as ${..}
parent bdabf8d6
Aucune branche associée trouvée
Aucune étiquette associée trouvée
Aucune requête de fusion associée trouvée
......@@ -16,16 +16,19 @@
# Premier jet
##
## Requirement to run this scrip
### util-linux is required to take in consideration bash option
getopt -T >/dev/null 2>&1
if (($? != 4)); then
echo "util-linux getopt is not installed. Aborting." >&2
exit 2
fi
##
usage() {
echo "Usage:"
echo " $0 [ --path=<path_to_check> | --path <path_to_check> | -p <path_to_check> ] [ --dry-run <0|1> ] [ --verbose | -v ]"
echo " $0 [ --help | -h ]"
echo " ${0} [ --path=<path_to_check> | --path <path_to_check> | -p <path_to_check> ] [ --dry-run <0|1> ] [ --verbose | -v ]"
echo " ${0} [ --help | -h ]"
echo
echo "Default path is /var/www/ "
echo "Dry-run is enabled by default"
......@@ -51,7 +54,7 @@ declare -A longoptspec
# way will have zero arguments by default.
longoptspec=( [path]=1 [dry-run]=1 )
optspec=":d:p:h-:v-:"
while getopts "$optspec" opt; do
while getopts "${optspec}" opt; do
while true; do
case "${opt}" in
-) #OPTARG is name-of-long-option or name-of-long-option=value
......@@ -59,25 +62,25 @@ while true; do
then
opt=${OPTARG/=*/}
((${#opt} <= 1)) && {
echo "Syntax error: Invalid long option '$opt'" >&2
echo "Syntax error: Invalid long option '${opt}'" >&2
exit 2
}
if ((longoptspec[\$opt] != 1))
then
echo "Syntax error: Option '$opt' does not support this syntax." >&2
echo "Syntax error: Option '${opt}' does not support this syntax." >&2
exit 2
fi
OPTARG=${OPTARG#*=}
else #with this --key value1 value2 format multiple arguments are possible
opt="$OPTARG"
opt="${OPTARG}"
((${#opt} <= 1)) && {
echo "Syntax error: Invalid long option '$opt'" >&2
echo "Syntax error: Invalid long option '${opt}'" >&2
exit 2
}
OPTARG=("${@:OPTIND:longoptspec[\$opt]}")
((OPTIND+=longoptspec[\$opt]))
((OPTIND > i)) && {
echo "Syntax error: Not all required arguments for option '$opt' are given." >&2
echo "Syntax error: Not all required arguments for option '${opt}' are given." >&2
exit 3
}
fi
......@@ -137,16 +140,16 @@ execute_cmd() {
then
cat
fi
if [[ $global_dry_run == 1 ]]; then
if [[ $global_verbose == 1 ]]; then
if [[ ${global_dry_run} == 1 ]]; then
if [[ ${global_verbose} == 1 ]]; then
printf -v cmd_str '%s ' "$@"
vprint " DRYRUN: $cmd_str" "WHITE"
vprint " DRYRUN: ${cmd_str}" "WHITE"
fi
else
"$@"
if [[ $global_verbose == 1 ]]; then
if [[ ${global_verbose} == 1 ]]; then
printf -v cmd_str '%s ' "$@"
vprint " RUN: $cmd_str" "WHITE"
vprint " RUN: ${cmd_str}" "WHITE"
fi
fi
}
......@@ -187,7 +190,7 @@ function vprint() {
# shellcheck disable=SC2034
WHITE='\033[0;37m' # White
printf "${!color}%s${NC}\n" "$msg"
printf "${!color}%s${NC}\n" "${msg}"
}
......@@ -197,7 +200,7 @@ function search_corrupted_pattern() {
local pattern
local files_contain_pattern
spip_dir=$1
spip_dir="${1}"
patterns_to_check="
@eval(@base64_decode
......@@ -206,16 +209,16 @@ function search_corrupted_pattern() {
"
for pattern in ${patterns_to_check};do
files_contain_pattern=$(grep -lr "$pattern" "$spip_dir")
if [[ -n $files_contain_pattern ]]; then
vprint "Some files have $pattern pattern" "RED"
if [[ $global_verbose == 1 ]]; then
files_contain_pattern=$(grep -lr "${pattern}" "${spip_dir}")
if [[ -n ${files_contain_pattern} ]]; then
vprint "Some files have ${pattern} pattern" "RED"
if [[ ${global_verbose} == 1 ]]; then
for file in ${files_contain_pattern};do
vprint " $file" "WHITE"
vprint " ${file}" "WHITE"
done;
fi
if [[ $(echo "${global_spip_hacked[@]}" | grep -ow "$spip_dir" | wc -w) -lt 1 ]]; then
global_spip_hacked+=("$spip_dir")
if [[ $(echo "${global_spip_hacked[@]}" | grep -ow "${spip_dir}" | wc -w) -lt 1 ]]; then
global_spip_hacked+=("${spip_dir}")
fi
fi
done;
......@@ -227,20 +230,20 @@ function clean_spip() {
local files_to_remove
local file
spip_dir=$1
spip_index_hacked=$(grep -q 'spip_pass' "$spip_dir/spip.php")
if [ "$spip_index_hacked" ];then
global_spip_hacked+=("$spip_dir")
spip_dir="${1}"
spip_index_hacked=$(grep -q 'spip_pass' "${spip_dir}/spip.php")
if [ "${spip_index_hacked}" ];then
global_spip_hacked+=("${spip_dir}")
fi
execute_cmd find "$spip_dir" -name '*.cache' -delete -print
execute_cmd rm -r "$spip_dir/tmp/"
execute_cmd mkdir -p "$spip_dir/tmp"
execute_cmd rm -r "$spip_dir/local/"
execute_cmd mkdir -p "$spip_dir/local"
execute_cmd wget https://git.spip.net/spip-contrib-outils/securite/raw/branch/master/ecran_securite.php -qO "$spip_dir/config/ecran_securite.php"
execute_cmd wget https://git.spip.net/spip/spip/raw/branch/master/spip.php -qO "$spip_dir/spip.php"
execute_cmd wget https://get.spip.net/spip_loader.php -qO "$spip_dir/spip_loader.php"
execute_cmd find "${spip_dir}" -name '*.cache' -delete -print
execute_cmd rm -r "${spip_dir}/tmp/"
execute_cmd mkdir -p "${spip_dir}/tmp"
execute_cmd rm -r "${spip_dir}/local/"
execute_cmd mkdir -p "${spip_dir}/local"
execute_cmd wget https://git.spip.net/spip-contrib-outils/securite/raw/branch/master/ecran_securite.php -qO "${spip_dir}/config/ecran_securite.php"
execute_cmd wget https://git.spip.net/spip/spip/raw/branch/master/spip.php -qO "${spip_dir}/spip.php"
execute_cmd wget https://get.spip.net/spip_loader.php -qO "${spip_dir}/spip_loader.php"
files_to_remove="
bin/.*
......@@ -275,12 +278,12 @@ function clean_spip() {
"
for file in ${files_to_remove}; do
#Check if files are present and notify about potential risk
if [[ $(find "$spip_dir" -regex "$spip_dir/$file$") ]]; then
if [[ $(echo "${global_spip_hacked[@]}" | grep -ow "$spip_dir" | wc -w) -lt 1 ]]; then
global_spip_hacked+=("$spip_dir")
if [[ $(find "${spip_dir}" -regex "${spip_dir}/${file}$") ]]; then
if [[ $(echo "${global_spip_hacked[@]}" | grep -ow "${spip_dir}" | wc -w) -lt 1 ]]; then
global_spip_hacked+=("${spip_dir}")
fi
fi
execute_cmd find "$spip_dir" -regex "$spip_dir/$file$" -delete -print
execute_cmd find "${spip_dir}" -regex "${spip_dir}/${file}$" -delete -print
done;
}
......@@ -289,12 +292,12 @@ function check_crontab() {
local user
spip_dir=$1
user=$(stat --printf %U "$spip_dir")
user=$(stat --printf %U "${spip_dir}")
# Process only once each crontab
if [[ $(echo "${global_crontab_users[@]}" | grep -ow "$user" | wc -w) -lt 1 ]]; then
global_crontab_users+=("$user")
crontab -lu "$user"
if [[ $(echo "${global_crontab_users[@]}" | grep -ow "${user}" | wc -w) -lt 1 ]]; then
global_crontab_users+=("${user}")
crontab -lu "${user}"
fi
}
......@@ -305,36 +308,36 @@ function search_spip() {
local spip_full_path
local spip_dir
www_dir="$1"
spip_files=$(find "$www_dir" -type d \( -path "*plugins-dist*" -o -path "*plugins*" -o -path "*ecrire/auth*" \) -prune -o -iname spip.php -print)
for spip in $spip_files;do
spip_full_path=$(realpath "$spip")
spip_dir=$(dirname "$spip_full_path")
global_spip_path_founds+=("$spip_dir")
www_dir="${1}"
spip_files=$(find "${www_dir}" -type d \( -path "*plugins-dist*" -o -path "*plugins*" -o -path "*ecrire/auth*" \) -prune -o -iname spip.php -print)
for spip in ${spip_files};do
spip_full_path=$(realpath "${spip}")
spip_dir=$(dirname "${spip_full_path}")
global_spip_path_founds+=("${spip_dir}")
done
}
if [[ $global_dry_run == 1 ]]; then
if [[ ${global_dry_run} == 1 ]]; then
vprint "Dry run enabled , action will not be executed" BLUE
else
vprint "Dry run disabled , all action will be executed" RED
fi
vprint "Search SPIP in $global_www_dir" "BLUE"
search_spip "$global_www_dir"
vprint "Search SPIP in ${global_www_dir}" "BLUE"
search_spip "${global_www_dir}"
for spip in "${global_spip_path_founds[@]}"; do
vprint "SPIP found : $spip" BLUE
clean_spip "$spip"
search_corrupted_pattern "$spip"
vprint "SPIP found : ${spip}" BLUE
clean_spip "${spip}"
search_corrupted_pattern "${spip}"
done;
vprint "Search crontab execution" "BLUE"
for spip in "${global_spip_path_founds[@]}"; do
check_crontab "$spip"
check_crontab "${spip}"
done;
vprint "SPIP to check manualy" "RED"
for spip in "${global_spip_hacked[@]}"; do
vprint "$spip" "WHITE"
vprint "${spip}" "WHITE"
done;
\ No newline at end of file
0% Chargement en cours ou .
You are about to add 0 people to the discussion. Proceed with caution.
Terminez d'abord l'édition de ce message.
Veuillez vous inscrire ou vous pour commenter